/* Generated by Edge Impulse
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
// Generated on: 20.04.2023 14:11:10

#include <stdio.h>
#include <stdlib.h>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

#ifndef EI_MAX_SCRATCH_BUFFER_COUNT
#define EI_MAX_SCRATCH_BUFFER_COUNT 4
#endif // EI_MAX_SCRATCH_BUFFER_COUNT

#ifndef EI_MAX_OVERFLOW_BUFFER_COUNT
#define EI_MAX_OVERFLOW_BUFFER_COUNT 10
#endif // EI_MAX_OVERFLOW_BUFFER_COUNT

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX) || defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
constexpr int kTensorArenaSize = 1344;
#else
constexpr int kTensorArenaSize = 320;
#endif

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

typedef struct {
  TfLiteTensor tensor;
  int16_t index;
} TfLiteTensorWithIndex;

typedef struct {
  TfLiteEvalTensor tensor;
  int16_t index;
} TfLiteEvalTensorWithIndex;

TfLiteContext ctx{};
static const int MAX_TFL_TENSOR_COUNT = 4;
static TfLiteTensorWithIndex tflTensors[MAX_TFL_TENSOR_COUNT];
static const int MAX_TFL_EVAL_COUNT = 4;
static TfLiteEvalTensorWithIndex tflEvalTensors[MAX_TFL_EVAL_COUNT];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[5];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,7 } };
const TfArray<1, float> quant0_scale = { 1, { 0.38827013969421387, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(16) int8_t tensor_data1[30*7] = { 
  -56, -62, 9, 71, -64, -2, 11, 
  3, 33, -44, 0, 23, 43, 16, 
  3, 55, 35, 14, -117, -35, -32, 
  -79, 13, 26, 5, -58, -20, 60, 
  1, -75, 47, 36, -58, 47, 23, 
  39, 73, -9, -3, 42, -34, -36, 
  -56, 74, -28, -61, -74, -44, -67, 
  -25, 4, -18, 67, 11, 54, -59, 
  23, -16, -72, 45, -24, -51, -59, 
  -10, 27, 27, 86, 48, -62, 24, 
  -60, -45, -57, 6, 24, -60, 51, 
  58, -4, -15, 106, 58, -61, 108, 
  28, -59, -43, 17, 20, -47, 70, 
  0, -68, 43, 15, 29, 4, 48, 
  -45, -45, -36, 67, 38, 14, -28, 
  -46, -14, 26, 28, -45, -1, 61, 
  -57, -9, 13, 22, -8, -35, 23, 
  -33, -51, -65, 70, 13, 60, 6, 
  -50, 30, 68, 42, 1, 33, -19, 
  -30, -2, 27, -12, -8, 29, 60, 
  -52, -72, -12, -26, -55, 10, 68, 
  12, -8, 10, 127, 126, 61, 104, 
  -74, 13, 0, -24, -18, -11, -25, 
  -20, -22, 20, -18, 12, 23, 0, 
  35, 66, 14, -22, -33, 0, 15, 
  -43, -23, -2, 66, 25, -10, -37, 
  64, 41, -35, -28, -51, -17, -100, 
  93, -59, -49, -62, -91, -35, 33, 
  20, 50, 35, 52, 12, -27, -46, 
  18, 55, -63, -29, -40, 66, -2, 
};
const TfArray<2, int> tensor_dimension1 = { 2, { 30,7 } };
const TfArray<1, float> quant1_scale = { 1, { 0.0052796178497374058, } };
const TfArray<1, int> quant1_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant1 = { (TfLiteFloatArray*)&quant1_scale, (TfLiteIntArray*)&quant1_zero, 0 };
const ALIGN(16) int32_t tensor_data2[30] = { 0, -142, 266, -13, 0, -28, 236, 0, 0, -398, 0, -176, 0, -20, 0, 0, 0, 0, -128, -18, 0, -282, 0, 0, -156, 0, 75, 267, -205, 286, };
const TfArray<1, int> tensor_dimension2 = { 1, { 30 } };
const TfArray<1, float> quant2_scale = { 1, { 0.0020499180536717176, } };
const TfArray<1, int> quant2_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant2 = { (TfLiteFloatArray*)&quant2_scale, (TfLiteIntArray*)&quant2_zero, 0 };
const ALIGN(16) int8_t tensor_data3[60*30] = { 
  -34, -16, 48, -10, -26, -28, 101, -50, -35, -20, 34, -56, 35, -20, -53, 14, 1, -33, -17, -43, 33, -34, 32, 44, 19, 45, 25, 36, -11, 59, 
  -35, 30, -20, 32, -9, -40, 33, 25, 9, 12, 53, 49, -36, 22, -17, -4, 10, -42, -66, -11, -25, -7, 28, 22, 20, 20, 29, 63, 6, -19, 
  -42, 16, 10, -53, 34, 26, 48, -3, 0, 44, -34, -2, 26, 29, 13, 27, 19, 53, -45, 43, -1, -29, 7, 49, 30, 13, -17, 21, -29, -42, 
  -35, 25, -7, 20, -4, 16, 75, -37, -4, 9, 3, -62, -3, -38, 35, -44, -29, -22, 14, 6, 51, -34, 32, -39, 0, -53, 19, 48, 44, 18, 
  8, -22, -49, 47, 51, 35, 1, -36, -50, 52, 19, 32, -9, -1, -5, -24, -44, -50, 37, -23, -40, 31, -13, 22, 37, -39, 41, -42, 45, -35, 
  33, -7, -50, -46, -32, 40, 29, 23, -5, 47, 43, -27, 9, -7, -18, -40, 39, -30, -20, -39, -19, -12, -27, 21, -13, -28, -35, -43, -40, 28, 
  43, 1, -60, 20, -54, -51, 23, 34, 9, -38, -38, 42, 22, 29, -9, 24, -56, 14, -26, -50, -40, -3, -21, 44, 50, 44, 36, 83, 1, 41, 
  -29, -16, -10, -22, -55, 8, -35, -29, 1, 52, 33, -28, -8, -47, 23, -38, -40, -32, -7, -22, -27, -39, 9, -54, -47, -3, -5, 7, -4, -5, 
  -37, 20, 36, 5, 34, 36, 9, 5, 10, -14, -29, -16, -8, -12, -42, -11, -39, -12, -47, -25, -41, -27, 5, -10, 32, -15, -36, 23, 10, 6, 
  -15, 31, -53, -12, -29, -8, 9, 32, -15, -3, -38, -60, 27, -52, 4, 19, 44, -45, 29, 19, -49, -35, -32, -53, 28, -22, -13, 37, 2, -39, 
  -2, 11, 45, 1, -45, -19, -46, 46, -34, -35, -22, 58, -47, -6, 49, 33, -50, 15, -35, -33, 25, 47, 34, -49, 46, -49, -14, -74, 38, 8, 
  8, -33, -26, -41, 56, -4, -36, 10, 5, 45, 17, -44, 20, 43, 41, 47, -20, 29, -11, 40, -51, -40, 45, 30, 43, 5, 23, -65, -60, 6, 
  37, -24, -51, -16, 24, -50, 48, 44, -12, 7, -50, -49, -34, -6, -6, 5, -31, -18, 49, -40, 16, 39, -36, 24, -54, 38, 37, 29, 46, 6, 
  -10, 37, -37, -42, -40, 5, 53, 40, 48, 4, -25, 50, -3, 5, 51, 34, 45, 44, 11, -11, 53, -55, 55, 43, 25, -42, 7, 33, 18, -30, 
  3, -2, 22, 7, -26, -49, 18, 55, 32, -23, 52, 37, -55, -26, 43, 4, 27, 19, 39, -24, 29, -2, -36, -50, 18, -17, 18, 8, 37, 58, 
  44, -6, 33, 32, 4, 51, 41, 50, 11, 62, 8, -11, 47, -59, -48, 35, 19, -44, 14, 22, 10, 20, -26, -30, -15, 56, -43, 23, 41, 59, 
  -17, 25, -5, -24, 32, -29, 20, -2, 44, 31, -18, -18, 16, -37, -53, 13, -31, -23, -39, -45, -22, -22, -9, -31, -48, 41, -41, -20, -44, 8, 
  48, -39, -1, 18, 32, 31, -32, 7, 18, 27, 26, 3, 44, 11, 48, 54, -48, -49, 10, -9, 17, 8, -22, 10, -15, 9, 41, -64, 6, -9, 
  35, -57, 48, 2, -15, -43, -11, -42, -35, 16, -55, -10, -43, 15, 8, 47, 45, 32, -49, -54, 50, -7, -39, 4, 39, -53, 11, 41, -58, -31, 
  17, -30, -18, 50, 1, -45, 15, 25, 53, -23, 18, -32, -2, -12, 18, 2, -21, 31, 36, -13, -28, 50, -8, 37, -11, -28, -43, -48, -31, 22, 
  15, -43, -14, 46, 49, 19, 22, -28, -47, 2, -47, -18, -11, -49, 2, 32, -19, -2, -32, 26, 21, 22, 12, 45, 30, 9, 15, -8, 28, 36, 
  -27, -14, -38, 13, -16, 38, -70, 52, 46, 7, -23, -7, 55, 32, 20, -20, 40, 18, 43, 1, 31, 58, -2, -21, 57, -8, 21, -36, 53, 32, 
  13, 47, 20, 58, -28, 10, 18, 35, -28, -20, 15, 26, 14, 46, -35, -33, 54, 52, 16, -5, 2, 14, 55, -53, -35, 11, 5, -17, 50, -27, 
  -33, 50, -7, -24, -50, -16, 65, 28, -20, 8, 13, -15, 6, 32, 0, -3, -21, 21, -28, 35, -18, -38, 21, -9, 21, 50, 35, 122, -20, 2, 
  -29, -32, -8, 33, 2, -29, 48, 22, 30, -37, -51, -54, 28, 9, 6, -28, -41, 41, 20, 55, -32, -12, 11, -46, -13, 23, 51, -3, -18, -53, 
  -43, 43, -35, 33, -44, 26, 43, 0, -36, -32, -31, 7, -54, -1, -35, -16, -18, 2, -34, -33, -22, -20, 37, 11, 36, -8, -44, -30, -41, -39, 
  6, 15, -11, 41, 3, 26, 26, -30, 19, 22, 5, -56, -7, 11, 29, 48, 9, 11, -35, -14, -39, -42, -46, 29, -5, -14, -6, 24, -48, -9, 
  -30, 36, -21, 38, 25, 22, -27, -50, 10, 16, 7, 11, 17, 49, -44, 37, -30, 6, 32, 37, -7, -17, 52, 24, 47, 5, 29, -19, -48, 29, 
  4, -20, -17, -50, 1, -17, -22, -2, 11, -19, -12, 12, -46, -37, -42, -30, -19, -4, -19, 30, -29, 27, 33, 23, 9, -35, -40, -64, 34, -63, 
  11, 34, -51, 20, -19, 4, -37, 28, 26, 7, -36, -16, 50, 11, -54, -19, 0, -55, 35, 24, 30, -21, -9, 13, -12, 12, -61, -44, 36, -26, 
  9, -57, -7, -25, -26, -30, 13, 26, 4, -8, -47, 38, 32, -34, -15, -10, -48, 14, 10, -57, -15, 48, 31, 22, 4, 49, -46, -48, 44, -19, 
  21, -38, -47, 41, 38, 47, -34, 44, -18, 17, -11, 20, 43, -23, -41, 40, 5, 6, 10, -42, 34, 30, 39, -29, -18, 39, -9, -59, 27, -15, 
  -27, 27, -23, -36, -34, -12, -21, -35, 3, -82, 42, 46, 18, 54, 22, -50, -56, 27, -35, 1, -10, 15, 3, -48, -46, -18, -1, 44, -25, 31, 
  -44, -57, 73, 45, 47, -2, -5, -53, -29, -66, 3, -2, 52, -6, 22, 7, -37, 7, 20, -44, 45, -95, 37, 1, -42, 52, 33, 16, -28, 38, 
  -41, 48, 5, 59, -42, -8, 65, -53, 35, -25, 2, -14, 38, -1, 6, -42, -10, 6, -58, 33, 29, 32, 16, -14, 21, -20, 5, 6, -22, 43, 
  5, -55, 39, 36, -50, -21, 44, 44, 8, -36, -42, 42, 13, 14, 5, -7, 48, -13, -9, -41, -34, -63, -2, 24, 34, 33, 6, 44, 13, 43, 
  42, 47, -6, 12, -45, 45, -101, 31, -38, -23, 22, 40, -9, 47, -16, 13, -21, -44, -30, -21, -9, -29, -48, 48, -7, 33, -57, -82, 24, 32, 
  -51, 33, -25, 29, 3, -17, 27, 44, -7, 9, 22, -3, 35, 32, 55, -52, 39, 6, 23, 27, -54, 47, 38, 38, 6, -47, -14, -19, -19, -14, 
  25, -49, 25, 19, 42, 11, -20, -36, 52, 18, 39, -50, -45, -24, -9, 39, -17, 35, 15, -38, -34, 18, 30, -19, 32, -21, -42, 39, 10, -51, 
  42, -25, 5, -4, -47, 29, -8, 8, -18, -22, 54, -38, -47, 51, -55, 0, -22, 26, 30, 11, -55, -50, 7, -18, 11, 6, -24, 8, -37, -16, 
  45, -24, -53, -44, -42, 43, -24, 24, 43, 28, -43, 15, 0, 14, 39, -16, -44, 50, 5, -1, 7, 7, 34, -30, -44, -50, 25, 35, 7, -44, 
  13, 3, -28, 1, -1, -5, -57, 9, 6, 14, -19, -42, 24, 50, -31, -23, 22, 32, 45, -33, 28, 28, -27, -42, -42, 15, 16, 38, 10, -18, 
  34, -31, -12, -3, -1, -32, 34, 15, 15, -2, 25, 41, 52, -1, -1, 50, -5, -36, 21, 21, -8, -27, 14, 20, 33, -14, 1, -8, -25, -49, 
  -8, 41, 12, 38, 14, 12, -46, -30, -32, 16, -17, -29, 14, 12, -53, 51, -32, 53, 40, -55, -24, -7, 40, 53, 13, 8, -42, -48, -48, -28, 
  -53, -4, 3, 21, 21, -42, 28, -23, 29, 27, -17, 36, 33, 49, 2, -1, -35, -41, -25, 33, 20, -38, -3, -43, -20, -3, -50, -30, 38, -8, 
  -37, -63, -54, -8, -51, -19, 31, 20, -25, -21, -31, -19, 8, -4, -4, -9, 35, -55, 30, 15, 9, 47, -48, 16, 21, -9, 14, 10, 6, -34, 
  33, -33, 15, -40, 44, -24, 8, 47, -47, -8, -42, -6, -3, 50, 56, 22, -41, 46, 8, -35, -41, -9, 33, -30, -11, 19, 1, 43, 1, -25, 
  -11, 34, -31, 42, -37, -44, 7, -17, 2, -11, 28, 1, 20, 44, 34, 34, -18, 30, -11, -47, -7, -16, -39, 0, -32, 50, 28, -11, -38, 18, 
  50, 22, -43, 18, 42, 31, -47, -9, 4, 12, -21, -49, 7, 8, 10, 28, -41, -16, -26, -38, -31, 18, -50, 11, -30, -23, -29, -8, -42, -25, 
  -39, -17, 53, -32, 16, 21, 97, -29, 32, -10, -14, -30, 50, -6, 45, -27, 14, 35, 5, 5, 42, -55, -41, -5, -56, 30, 53, 105, 27, -49, 
  -33, -44, -8, -16, -23, 10, 33, 12, -17, -41, -55, -30, 5, 42, 19, -21, -21, 50, -48, 46, -52, -48, 27, -50, 16, 34, 5, -5, -10, -11, 
  5, -86, 41, 35, 28, 19, 13, 44, 48, -13, 28, 30, -55, 10, -50, 44, -18, -33, 73, 127, 31, 17, -13, -23, -35, -37, -39, -35, -14, -4, 
  -1, -26, 52, 38, 46, 38, 76, -48, -25, -27, 53, -37, 0, 18, 49, -40, 38, 8, -44, 22, 0, 4, 50, 42, -31, -30, 6, -5, -7, -11, 
  25, 19, 10, 56, 23, -36, -3, 6, -7, -8, 53, 35, -34, -42, 1, -34, -3, 27, -11, 24, -37, -50, -47, 46, 35, 7, -16, 58, 27, -3, 
  46, -63, -59, 51, -2, 12, -1, -23, -7, -37, 27, 7, -5, 25, 36, -1, 18, -26, 4, 30, 0, -12, 16, -22, -56, 42, 32, 15, 6, 24, 
  -11, 51, -4, 8, -33, 41, 14, 42, 37, 2, 11, 5, 34, -42, 23, -3, -9, -52, 41, -16, 9, 53, 20, 52, -43, -41, -36, 41, -45, -13, 
  -15, 30, -13, 34, 29, -36, -30, 44, -26, 32, 21, 0, 1, -51, 19, 6, -41, -2, 52, 23, -22, 35, -44, 17, -50, -8, -17, 13, 34, -11, 
  -9, 48, 6, -41, 44, -42, -23, -3, 29, -10, -12, -20, 2, -33, -21, -19, 49, 37, -5, -14, -31, -41, 45, -6, 31, -37, -12, -14, 28, -24, 
  -2, 38, 49, -8, -6, -6, 72, -27, -55, 4, -9, -33, -10, 35, 22, -17, -17, 19, 45, 19, -15, -37, -27, 19, 25, -9, 38, 71, -25, -36, 
  32, 4, 38, 57, -51, -38, -30, -23, -26, -39, -14, -24, -54, 21, -52, -19, -20, -53, 34, -11, -47, -48, -17, -12, 39, 41, 28, 15, -64, -17, 
};
const TfArray<2, int> tensor_dimension3 = { 2, { 60,30 } };
const TfArray<1, float> quant3_scale = { 1, { 0.0046116984449326992, } };
const TfArray<1, int> quant3_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant3 = { (TfLiteFloatArray*)&quant3_scale, (TfLiteIntArray*)&quant3_zero, 0 };
const ALIGN(16) int32_t tensor_data4[60] = { 342, 288, -356, 386, -517, -41, -127, 0, 469, -34, -26, -53, 0, -122, -264, -331, 0, 74, -11, 0, 381, -256, 644, 586, 0, -38, -35, -142, -40, -35, -15, -141, 293, 1140, -7, 217, -57, -1, -50, -31, 9, -27, 0, 0, -31, -36, -31, 0, 0, -131, -75, 276, 240, -367, -51, 0, 0, -31, -314, -55, };
const TfArray<1, int> tensor_dimension4 = { 1, { 60 } };
const TfArray<1, float> quant4_scale = { 1, { 0.00096076668705791235, } };
const TfArray<1, int> quant4_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant4 = { (TfLiteFloatArray*)&quant4_scale, (TfLiteIntArray*)&quant4_zero, 0 };
const ALIGN(16) int8_t tensor_data5[10*60] = { 
  -21, -27, -7, -7, 18, -43, -2, -33, -27, -24, 36, 10, 9, 1, 8, 20, -17, -6, -32, 36, -2, 14, -22, -6, 11, 9, 1, 37, 25, -32, -19, 38, 16, -127, 8, -18, -23, 25, 8, -23, 25, -4, 31, 25, -12, -30, 0, -13, -4, 9, 0, -49, -44, 25, 32, 14, -27, 10, 21, -18, 
  23, 17, 8, -38, -37, 16, 9, 1, -19, -10, -12, 30, -7, 20, 25, -18, -17, -19, 30, -33, -6, -4, 32, -29, 22, -40, 5, -16, -23, -2, 17, -27, 4, 11, 30, -18, -39, 27, -30, -20, 28, 3, 8, -16, 36, 27, 5, -11, -31, -20, 14, -11, 17, -21, 1, -22, -21, -39, -5, 34, 
  -38, 17, 14, 6, 36, 26, 33, 7, 5, 33, 4, 17, -21, 3, 32, -7, 2, 19, -24, 21, -36, 2, -17, -22, -21, 31, 17, 25, 14, 26, 12, -2, -17, -121, -6, 16, -14, -9, 22, 20, -18, -28, 22, -31, 21, 22, -9, -4, -12, -7, -22, 68, 34, -25, -12, -32, 27, 1, 20, -20, 
  -36, 19, -3, 23, -23, 43, 15, -4, 25, -5, 29, 6, -36, -16, -3, -13, 12, 30, -30, 2, 33, -4, 18, -1, 24, -13, 24, 35, 28, 5, -34, 25, 62, 122, -16, 20, -5, 12, -23, 35, -9, 32, -33, -32, -32, 9, -17, 14, 23, -38, -18, -6, 36, -39, 14, -29, -38, 3, -10, -21, 
  -14, 21, -27, 10, -4, -34, 17, -38, -6, 10, 35, -36, 3, -35, -12, 26, 8, -26, -31, 18, 37, 21, 30, -68, 0, 24, 17, -11, 17, 22, 13, 9, 7, -39, -32, 15, 35, 6, -33, 14, -18, 4, -32, -4, 16, 3, 2, -26, -8, -42, -9, -65, 15, -28, 20, 25, 23, 29, -36, 42, 
  -4, -1, 26, -37, -15, 3, -28, -4, 22, 13, -30, -13, 2, -39, 12, -7, 36, 6, 18, 27, 16, -11, -12, -25, 11, -34, -2, 12, -11, 36, 34, -22, 33, 14, -31, 20, 6, 18, 36, -39, 34, 26, 15, 23, -38, 37, 0, -34, 30, 25, 15, 32, 13, 6, -15, -31, 1, -39, -15, -24, 
  -41, -6, 1, 4, 4, 30, 21, 35, 7, 4, 19, 19, 28, 23, -42, -17, -17, -7, 6, 34, -23, -26, -6, -22, 31, 4, -8, 28, 15, -6, -19, 33, 12, -33, 16, -19, -17, -36, -25, 20, 1, 42, -6, 4, 33, 30, 34, 23, 13, -40, 11, 18, -35, -21, 9, 23, 2, -17, -4, 30, 
  29, 7, -7, 33, -24, -24, -17, -8, 36, 26, -29, 23, -4, -37, -27, -24, -14, -38, 10, 30, 12, -31, -28, 13, 4, -10, -17, 6, -24, 40, 28, -13, 14, -31, 1, 14, 12, 21, 20, -11, 22, 16, -31, -22, -37, 35, 10, 23, 32, 32, -11, 37, 11, 22, -15, 15, -24, 22, -31, 38, 
  2, 14, 4, -30, -24, 26, -23, 19, -28, -34, -24, 15, -1, -33, -37, -27, -30, -24, -6, 6, 8, 7, -18, -17, 2, -27, 20, 6, -28, 5, 7, -23, -15, -20, 36, 1, -30, -2, -19, 6, -17, -36, -8, -31, 26, 24, -25, 32, -5, 25, 15, 26, -24, -36, -38, 9, -18, 4, -36, 14, 
  43, 0, -19, 37, -33, -12, 33, -33, 4, 33, 8, -23, -21, -2, 4, 12, 5, -27, 9, 1, 32, -26, 24, 71, -17, 20, -20, 15, 30, -25, 29, -37, 33, 3, 26, 30, -41, 18, -13, -24, 32, 12, 14, 8, -7, 19, 15, 8, -29, 44, -4, 47, 4, 7, -23, -6, 4, -7, 6, -4, 
};
const TfArray<2, int> tensor_dimension5 = { 2, { 10,60 } };
const TfArray<1, float> quant5_scale = { 1, { 0.0074564479291439056, } };
const TfArray<1, int> quant5_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant5 = { (TfLiteFloatArray*)&quant5_scale, (TfLiteIntArray*)&quant5_zero, 0 };
const ALIGN(16) int32_t tensor_data6[10] = { -275, -27, -280, 274, -242, 0, -49, 7, 0, 143, };
const TfArray<1, int> tensor_dimension6 = { 1, { 10 } };
const TfArray<1, float> quant6_scale = { 1, { 0.0011125734308734536, } };
const TfArray<1, int> quant6_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(16) int8_t tensor_data7[3*10] = { 
  41, 42, -35, 5, -59, -105, 18, -127, 90, -68, 
  -33, 76, 93, -111, -94, -29, 60, -112, 46, 97, 
  -103, -97, -115, 57, -106, -117, -112, 15, -108, 103, 
};
const TfArray<2, int> tensor_dimension7 = { 2, { 3,10 } };
const TfArray<1, float> quant7_scale = { 1, { 0.0054706521332263947, } };
const TfArray<1, int> quant7_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(8) int32_t tensor_data8[3] = { -485, -519, 1314, };
const TfArray<1, int> tensor_dimension8 = { 1, { 3 } };
const TfArray<1, float> quant8_scale = { 1, { 0.00040846382034942508, } };
const TfArray<1, int> quant8_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const TfArray<2, int> tensor_dimension9 = { 2, { 1,30 } };
const TfArray<1, float> quant9_scale = { 1, { 0.20833250880241394, } };
const TfArray<1, int> quant9_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const TfArray<2, int> tensor_dimension10 = { 2, { 1,60 } };
const TfArray<1, float> quant10_scale = { 1, { 0.14920957386493683, } };
const TfArray<1, int> quant10_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant10 = { (TfLiteFloatArray*)&quant10_scale, (TfLiteIntArray*)&quant10_zero, 0 };
const TfArray<2, int> tensor_dimension11 = { 2, { 1,10 } };
const TfArray<1, float> quant11_scale = { 1, { 0.074664555490016937, } };
const TfArray<1, int> quant11_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant11 = { (TfLiteFloatArray*)&quant11_scale, (TfLiteIntArray*)&quant11_zero, 0 };
const TfArray<2, int> tensor_dimension12 = { 2, { 1,3 } };
const TfArray<1, float> quant12_scale = { 1, { 0.11600241810083389, } };
const TfArray<1, int> quant12_zero = { 1, { 48 } };
const TfLiteAffineQuantization quant12 = { (TfLiteFloatArray*)&quant12_scale, (TfLiteIntArray*)&quant12_zero, 0 };
const TfArray<2, int> tensor_dimension13 = { 2, { 1,3 } };
const TfArray<1, float> quant13_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant13_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant13 = { (TfLiteFloatArray*)&quant13_scale, (TfLiteIntArray*)&quant13_zero, 0 };
const TfLiteFullyConnectedParams opdata0 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs0 = { 3, { 0,1,2 } };
const TfArray<1, int> outputs0 = { 1, { 9 } };
const TfLiteFullyConnectedParams opdata1 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs1 = { 3, { 9,3,4 } };
const TfArray<1, int> outputs1 = { 1, { 10 } };
const TfLiteFullyConnectedParams opdata2 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs2 = { 3, { 10,5,6 } };
const TfArray<1, int> outputs2 = { 1, { 11 } };
const TfLiteFullyConnectedParams opdata3 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs3 = { 3, { 11,7,8 } };
const TfArray<1, int> outputs3 = { 1, { 12 } };
const TfLiteSoftmaxParams opdata4 = { 1 };
const TfArray<1, int> inputs4 = { 1, { 12 } };
const TfArray<1, int> outputs4 = { 1, { 13 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension0, 7, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 210, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant1))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 120, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant2))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 1800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant3))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 240, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant4))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 600, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant5))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 40, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 30, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 12, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 64, (TfLiteIntArray*)&tensor_dimension9, 30, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension10, 60, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant10))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 64, (TfLiteIntArray*)&tensor_dimension11, 10, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant11))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 16, (TfLiteIntArray*)&tensor_dimension12, 3, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant12))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension13, 3, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant13))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_SOFTMAX, },
};

static void init_tflite_tensor(size_t i, TfLiteTensor *tensor) {
  tensor->type = tensorData[i].type;
  tensor->is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
  tensor->allocation_type = tensorData[i].allocation_type;
#else
  tensor->allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
  tensor->bytes = tensorData[i].bytes;
  tensor->dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
  if(tensor->allocation_type == kTfLiteArenaRw){
    uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

    tensor->data.data =  start;
  }
  else {
      tensor->data.data = tensorData[i].data;
  }
#else
  tensor->data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
  tensor->quantization = tensorData[i].quantization;
  if (tensor->quantization.type == kTfLiteAffineQuantization) {
    TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
    tensor->params.scale = quant->scale->data[0];
    tensor->params.zero_point = quant->zero_point->data[0];
  }

}

static void init_tflite_eval_tensor(size_t i, TfLiteEvalTensor *tensor) {
  tensor->type = tensorData[i].type;

  tensor->dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
  auto allocation_type = tensorData[i].allocation_type;
  if(allocation_type == kTfLiteArenaRw) {
    uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

    tensor->data.data =  start;
  }
  else {
    tensor->data.data = tensorData[i].data;
  }
#else
  tensor->data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
}

static void* overflow_buffers[EI_MAX_OVERFLOW_BUFFER_COUNT];
static size_t overflow_buffers_ix = 0;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    if (overflow_buffers_ix > EI_MAX_OVERFLOW_BUFFER_COUNT - 1) {
      ei_printf("ERR: Failed to allocate persistent buffer of size %d, does not fit in tensor arena and reached EI_MAX_OVERFLOW_BUFFER_COUNT\n",
        (int)bytes);
      return NULL;
    }

    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      ei_printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers[overflow_buffers_ix++] = ptr;
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static scratch_buffer_t scratch_buffers[EI_MAX_SCRATCH_BUFFER_COUNT];
static size_t scratch_buffers_ix = 0;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  if (scratch_buffers_ix > EI_MAX_SCRATCH_BUFFER_COUNT - 1) {
    ei_printf("ERR: Failed to allocate scratch buffer of size %d, reached EI_MAX_SCRATCH_BUFFER_COUNT\n",
      (int)bytes);
    return kTfLiteError;
  }

  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    ei_printf("ERR: Failed to allocate scratch buffer of size %d\n",
      (int)bytes);
    return kTfLiteError;
  }

  scratch_buffers[scratch_buffers_ix] = b;
  *buffer_idx = scratch_buffers_ix;

  scratch_buffers_ix++;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > (int)scratch_buffers_ix) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static const uint16_t TENSOR_IX_UNUSED = 0x7FFF;

static void ResetTensors() {
  for (size_t ix = 0; ix < MAX_TFL_TENSOR_COUNT; ix++) {
    tflTensors[ix].index = TENSOR_IX_UNUSED;
  }
  for (size_t ix = 0; ix < MAX_TFL_EVAL_COUNT; ix++) {
    tflEvalTensors[ix].index = TENSOR_IX_UNUSED;
  }
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {

  for (size_t ix = 0; ix < MAX_TFL_TENSOR_COUNT; ix++) {
    // already used? OK!
    if (tflTensors[ix].index == tensor_idx) {
      return &tflTensors[ix].tensor;
    }
    // passed all the ones we've used, so end of the list?
    if (tflTensors[ix].index == TENSOR_IX_UNUSED) {
      // init the tensor
      init_tflite_tensor(tensor_idx, &tflTensors[ix].tensor);
      tflTensors[ix].index = tensor_idx;
      return &tflTensors[ix].tensor;
    }
  }

  ei_printf("ERR: GetTensor called beyond MAX_TFL_TENSOR_COUNT (%d)\n", MAX_TFL_TENSOR_COUNT);
  return nullptr;
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {

  for (size_t ix = 0; ix < MAX_TFL_EVAL_COUNT; ix++) {
    // already used? OK!
    if (tflEvalTensors[ix].index == tensor_idx) {
      return &tflEvalTensors[ix].tensor;
    }
    // passed all the ones we've used, so end of the list?
    if (tflEvalTensors[ix].index == TENSOR_IX_UNUSED) {
      // init the tensor
      init_tflite_eval_tensor(tensor_idx, &tflEvalTensors[ix].tensor);
      tflEvalTensors[ix].index = tensor_idx;
      return &tflEvalTensors[ix].tensor;
    }
  }

  ei_printf("ERR: GetTensor called beyond MAX_TFL_EVAL_COUNT (%d)\n", (int)MAX_TFL_EVAL_COUNT);
  return nullptr;
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    ei_printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors_size = 14;
  for (size_t i = 0; i < 14; ++i) {
    TfLiteTensor tensor;
    init_tflite_tensor(i, &tensor);
    if (tensor.allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tensor.data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    ei_printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_FULLY_CONNECTED] = Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for (size_t i = 0; i < 5; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
tflNodes[i].custom_initial_data = nullptr;
      tflNodes[i].custom_initial_data_size = 0;
if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for (size_t i = 0; i < 5; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      ResetTensors();

      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteStatus trained_model_input(int index, TfLiteTensor *tensor) {
  init_tflite_tensor(inTensorIndices[index], tensor);
  return kTfLiteOk;
}

static const int outTensorIndices[] = {
  13, 
};
TfLiteStatus trained_model_output(int index, TfLiteTensor *tensor) {
  init_tflite_tensor(outTensorIndices[index], tensor);
  return kTfLiteOk;
}

TfLiteStatus trained_model_invoke() {
  for (size_t i = 0; i < 5; ++i) {
    ResetTensors();

    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif

  // scratch buffers are allocated within the arena, so just reset the counter so memory can be reused
  scratch_buffers_ix = 0;

  // overflow buffers are on the heap, so free them first
  for (size_t ix = 0; ix < overflow_buffers_ix; ix++) {
    ei_free(overflow_buffers[ix]);
  }
  overflow_buffers_ix = 0;
  return kTfLiteOk;
}
